Skip excessive blank lines before commit body
[git/dscho.git] / git-reset.sh
bloba9693701a34dac623fcddb1943ffe326bdb05405
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Linus Torvalds and Junio C Hamano
5 USAGE='[--mixed | --soft | --hard] [<commit-ish>] [ [--] <paths>...]'
6 SUBDIRECTORY_OK=Yes
7 . git-sh-setup
8 set_reflog_action "reset $*"
10 update= reset_type=--mixed
11 unset rev
13 while case $# in 0) break ;; esac
15 case "$1" in
16 --mixed | --soft | --hard)
17 reset_type="$1"
19 --)
20 break
22 -*)
23 usage
26 rev=$(git-rev-parse --verify "$1") || exit
27 shift
28 break
30 esac
31 shift
32 done
34 : ${rev=HEAD}
35 rev=$(git-rev-parse --verify $rev^0) || exit
37 # Skip -- in "git reset HEAD -- foo" and "git reset -- foo".
38 case "$1" in --) shift ;; esac
40 # git reset --mixed tree [--] paths... can be used to
41 # load chosen paths from the tree into the index without
42 # affecting the working tree nor HEAD.
43 if test $# != 0
44 then
45 test "$reset_type" == "--mixed" ||
46 die "Cannot do partial $reset_type reset."
47 git ls-tree -r --full-name $rev -- "$@" |
48 git update-index --add --index-info || exit
49 git update-index --refresh
50 exit
53 TOP=$(git-rev-parse --show-cdup)
54 if test ! -z "$TOP"
55 then
56 cd "$TOP"
59 if test "$reset_type" = "--hard"
60 then
61 update=-u
64 # Soft reset does not touch the index file nor the working tree
65 # at all, but requires them in a good order. Other resets reset
66 # the index file to the tree object we are switching to.
67 if test "$reset_type" = "--soft"
68 then
69 if test -f "$GIT_DIR/MERGE_HEAD" ||
70 test "" != "$(git-ls-files --unmerged)"
71 then
72 die "Cannot do a soft reset in the middle of a merge."
74 else
75 git-read-tree --reset $update "$rev" || exit
78 # Any resets update HEAD to the head being switched to.
79 if orig=$(git-rev-parse --verify HEAD 2>/dev/null)
80 then
81 echo "$orig" >"$GIT_DIR/ORIG_HEAD"
82 else
83 rm -f "$GIT_DIR/ORIG_HEAD"
85 git-update-ref -m "$GIT_REFLOG_ACTION" HEAD "$rev"
86 update_ref_status=$?
88 case "$reset_type" in
89 --hard )
90 test $update_ref_status = 0 && {
91 echo -n "HEAD is now at "
92 GIT_PAGER= git log --max-count=1 --pretty=oneline \
93 --abbrev-commit HEAD
96 --soft )
97 ;; # Nothing else to do
98 --mixed )
99 # Report what has not been updated.
100 git-update-index --refresh
102 esac
104 rm -f "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/rr-cache/MERGE_RR" \
105 "$GIT_DIR/SQUASH_MSG" "$GIT_DIR/MERGE_MSG"
107 exit $update_ref_status